package com.gyee.frame.model.auto;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 *  ReportdetailExample
 * @author gyee_自动生成
 * @email 1@qq.com
 * @date 2020-03-02 15:04:24
 */
public class ReportdetailExample {

    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    public ReportdetailExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }
				
        public Criteria andDetailreportidIsNull() {
            addCriterion("detailreportid is null");
            return (Criteria) this;
        }

        public Criteria andDetailreportidIsNotNull() {
            addCriterion("detailreportid is not null");
            return (Criteria) this;
        }

        public Criteria andDetailreportidEqualTo(String value) {
            addCriterion("detailreportid =", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidNotEqualTo(String value) {
            addCriterion("detailreportid <>", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidGreaterThan(String value) {
            addCriterion("detailreportid >", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidGreaterThanOrEqualTo(String value) {
            addCriterion("detailreportid >=", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidLessThan(String value) {
            addCriterion("detailreportid <", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidLessThanOrEqualTo(String value) {
            addCriterion("detailreportid <=", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidLike(String value) {
            addCriterion("detailreportid like", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidNotLike(String value) {
            addCriterion("detailreportid not like", value, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidIn(List<String> values) {
            addCriterion("detailreportid in", values, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidNotIn(List<String> values) {
            addCriterion("detailreportid not in", values, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidBetween(String value1, String value2) {
            addCriterion("detailreportid between", value1, value2, "detailreportid");
            return (Criteria) this;
        }

        public Criteria andDetailreportidNotBetween(String value1, String value2) {
            addCriterion("detailreportid not between", value1, value2, "detailreportid");
            return (Criteria) this;
        }
        
			
        public Criteria andLongitudeIsNull() {
            addCriterion("longitude is null");
            return (Criteria) this;
        }

        public Criteria andLongitudeIsNotNull() {
            addCriterion("longitude is not null");
            return (Criteria) this;
        }

        public Criteria andLongitudeEqualTo(String value) {
            addCriterion("longitude =", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotEqualTo(String value) {
            addCriterion("longitude <>", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeGreaterThan(String value) {
            addCriterion("longitude >", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeGreaterThanOrEqualTo(String value) {
            addCriterion("longitude >=", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeLessThan(String value) {
            addCriterion("longitude <", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeLessThanOrEqualTo(String value) {
            addCriterion("longitude <=", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeLike(String value) {
            addCriterion("longitude like", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotLike(String value) {
            addCriterion("longitude not like", value, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeIn(List<String> values) {
            addCriterion("longitude in", values, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotIn(List<String> values) {
            addCriterion("longitude not in", values, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeBetween(String value1, String value2) {
            addCriterion("longitude between", value1, value2, "longitude");
            return (Criteria) this;
        }

        public Criteria andLongitudeNotBetween(String value1, String value2) {
            addCriterion("longitude not between", value1, value2, "longitude");
            return (Criteria) this;
        }
        
			
        public Criteria andLatitudeIsNull() {
            addCriterion("latitude is null");
            return (Criteria) this;
        }

        public Criteria andLatitudeIsNotNull() {
            addCriterion("latitude is not null");
            return (Criteria) this;
        }

        public Criteria andLatitudeEqualTo(String value) {
            addCriterion("latitude =", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotEqualTo(String value) {
            addCriterion("latitude <>", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeGreaterThan(String value) {
            addCriterion("latitude >", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeGreaterThanOrEqualTo(String value) {
            addCriterion("latitude >=", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeLessThan(String value) {
            addCriterion("latitude <", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeLessThanOrEqualTo(String value) {
            addCriterion("latitude <=", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeLike(String value) {
            addCriterion("latitude like", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotLike(String value) {
            addCriterion("latitude not like", value, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeIn(List<String> values) {
            addCriterion("latitude in", values, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotIn(List<String> values) {
            addCriterion("latitude not in", values, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeBetween(String value1, String value2) {
            addCriterion("latitude between", value1, value2, "latitude");
            return (Criteria) this;
        }

        public Criteria andLatitudeNotBetween(String value1, String value2) {
            addCriterion("latitude not between", value1, value2, "latitude");
            return (Criteria) this;
        }
        
			
        public Criteria andAreanameIsNull() {
            addCriterion("areaname is null");
            return (Criteria) this;
        }

        public Criteria andAreanameIsNotNull() {
            addCriterion("areaname is not null");
            return (Criteria) this;
        }

        public Criteria andAreanameEqualTo(String value) {
            addCriterion("areaname =", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameNotEqualTo(String value) {
            addCriterion("areaname <>", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameGreaterThan(String value) {
            addCriterion("areaname >", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameGreaterThanOrEqualTo(String value) {
            addCriterion("areaname >=", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameLessThan(String value) {
            addCriterion("areaname <", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameLessThanOrEqualTo(String value) {
            addCriterion("areaname <=", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameLike(String value) {
            addCriterion("areaname like", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameNotLike(String value) {
            addCriterion("areaname not like", value, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameIn(List<String> values) {
            addCriterion("areaname in", values, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameNotIn(List<String> values) {
            addCriterion("areaname not in", values, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameBetween(String value1, String value2) {
            addCriterion("areaname between", value1, value2, "areaname");
            return (Criteria) this;
        }

        public Criteria andAreanameNotBetween(String value1, String value2) {
            addCriterion("areaname not between", value1, value2, "areaname");
            return (Criteria) this;
        }
        
			
        public Criteria andNameIsNull() {
            addCriterion("name is null");
            return (Criteria) this;
        }

        public Criteria andNameIsNotNull() {
            addCriterion("name is not null");
            return (Criteria) this;
        }

        public Criteria andNameEqualTo(String value) {
            addCriterion("name =", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotEqualTo(String value) {
            addCriterion("name <>", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThan(String value) {
            addCriterion("name >", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameGreaterThanOrEqualTo(String value) {
            addCriterion("name >=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThan(String value) {
            addCriterion("name <", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLessThanOrEqualTo(String value) {
            addCriterion("name <=", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameLike(String value) {
            addCriterion("name like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotLike(String value) {
            addCriterion("name not like", value, "name");
            return (Criteria) this;
        }

        public Criteria andNameIn(List<String> values) {
            addCriterion("name in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotIn(List<String> values) {
            addCriterion("name not in", values, "name");
            return (Criteria) this;
        }

        public Criteria andNameBetween(String value1, String value2) {
            addCriterion("name between", value1, value2, "name");
            return (Criteria) this;
        }

        public Criteria andNameNotBetween(String value1, String value2) {
            addCriterion("name not between", value1, value2, "name");
            return (Criteria) this;
        }
        
			
        public Criteria andPowerstationidIsNull() {
            addCriterion("powerstationid is null");
            return (Criteria) this;
        }

        public Criteria andPowerstationidIsNotNull() {
            addCriterion("powerstationid is not null");
            return (Criteria) this;
        }

        public Criteria andPowerstationidEqualTo(String value) {
            addCriterion("powerstationid =", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidNotEqualTo(String value) {
            addCriterion("powerstationid <>", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidGreaterThan(String value) {
            addCriterion("powerstationid >", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidGreaterThanOrEqualTo(String value) {
            addCriterion("powerstationid >=", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidLessThan(String value) {
            addCriterion("powerstationid <", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidLessThanOrEqualTo(String value) {
            addCriterion("powerstationid <=", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidLike(String value) {
            addCriterion("powerstationid like", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidNotLike(String value) {
            addCriterion("powerstationid not like", value, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidIn(List<String> values) {
            addCriterion("powerstationid in", values, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidNotIn(List<String> values) {
            addCriterion("powerstationid not in", values, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidBetween(String value1, String value2) {
            addCriterion("powerstationid between", value1, value2, "powerstationid");
            return (Criteria) this;
        }

        public Criteria andPowerstationidNotBetween(String value1, String value2) {
            addCriterion("powerstationid not between", value1, value2, "powerstationid");
            return (Criteria) this;
        }
        
			
        public Criteria andPowerstationnameIsNull() {
            addCriterion("powerstationname is null");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameIsNotNull() {
            addCriterion("powerstationname is not null");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameEqualTo(String value) {
            addCriterion("powerstationname =", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameNotEqualTo(String value) {
            addCriterion("powerstationname <>", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameGreaterThan(String value) {
            addCriterion("powerstationname >", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameGreaterThanOrEqualTo(String value) {
            addCriterion("powerstationname >=", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameLessThan(String value) {
            addCriterion("powerstationname <", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameLessThanOrEqualTo(String value) {
            addCriterion("powerstationname <=", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameLike(String value) {
            addCriterion("powerstationname like", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameNotLike(String value) {
            addCriterion("powerstationname not like", value, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameIn(List<String> values) {
            addCriterion("powerstationname in", values, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameNotIn(List<String> values) {
            addCriterion("powerstationname not in", values, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameBetween(String value1, String value2) {
            addCriterion("powerstationname between", value1, value2, "powerstationname");
            return (Criteria) this;
        }

        public Criteria andPowerstationnameNotBetween(String value1, String value2) {
            addCriterion("powerstationname not between", value1, value2, "powerstationname");
            return (Criteria) this;
        }
        
			
        public Criteria andArelongitudeIsNull() {
            addCriterion("arelongitude is null");
            return (Criteria) this;
        }

        public Criteria andArelongitudeIsNotNull() {
            addCriterion("arelongitude is not null");
            return (Criteria) this;
        }

        public Criteria andArelongitudeEqualTo(String value) {
            addCriterion("arelongitude =", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeNotEqualTo(String value) {
            addCriterion("arelongitude <>", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeGreaterThan(String value) {
            addCriterion("arelongitude >", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeGreaterThanOrEqualTo(String value) {
            addCriterion("arelongitude >=", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeLessThan(String value) {
            addCriterion("arelongitude <", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeLessThanOrEqualTo(String value) {
            addCriterion("arelongitude <=", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeLike(String value) {
            addCriterion("arelongitude like", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeNotLike(String value) {
            addCriterion("arelongitude not like", value, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeIn(List<String> values) {
            addCriterion("arelongitude in", values, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeNotIn(List<String> values) {
            addCriterion("arelongitude not in", values, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeBetween(String value1, String value2) {
            addCriterion("arelongitude between", value1, value2, "arelongitude");
            return (Criteria) this;
        }

        public Criteria andArelongitudeNotBetween(String value1, String value2) {
            addCriterion("arelongitude not between", value1, value2, "arelongitude");
            return (Criteria) this;
        }
        
			
        public Criteria andArelatitudeIsNull() {
            addCriterion("arelatitude is null");
            return (Criteria) this;
        }

        public Criteria andArelatitudeIsNotNull() {
            addCriterion("arelatitude is not null");
            return (Criteria) this;
        }

        public Criteria andArelatitudeEqualTo(String value) {
            addCriterion("arelatitude =", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeNotEqualTo(String value) {
            addCriterion("arelatitude <>", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeGreaterThan(String value) {
            addCriterion("arelatitude >", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeGreaterThanOrEqualTo(String value) {
            addCriterion("arelatitude >=", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeLessThan(String value) {
            addCriterion("arelatitude <", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeLessThanOrEqualTo(String value) {
            addCriterion("arelatitude <=", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeLike(String value) {
            addCriterion("arelatitude like", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeNotLike(String value) {
            addCriterion("arelatitude not like", value, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeIn(List<String> values) {
            addCriterion("arelatitude in", values, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeNotIn(List<String> values) {
            addCriterion("arelatitude not in", values, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeBetween(String value1, String value2) {
            addCriterion("arelatitude between", value1, value2, "arelatitude");
            return (Criteria) this;
        }

        public Criteria andArelatitudeNotBetween(String value1, String value2) {
            addCriterion("arelatitude not between", value1, value2, "arelatitude");
            return (Criteria) this;
        }
        
	}

    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}